/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.example.struts.admin.actions;

import groovy.lang.GroovyShell;

import java.security.AccessControlContext;
import java.security.AccessController;
import java.security.PrivilegedAction;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.jguard.core.authorization.policy.AccessControlContextUtils;
import net.sf.jguard.core.principals.RolePrincipal;
import net.sf.jguard.example.struts.actions.BaseAction;
import net.sf.jguard.ext.SecurityConstants;
import net.sf.jguard.ext.authorization.AuthorizationException;
import net.sf.jguard.ext.authorization.manager.AuthorizationManager;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;
import org.codehaus.groovy.control.CompilationFailedException;
/**
 * a groovy dedicated action to show how to execute code in a "safe" sandbox.
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 */
public class GroovyDispatchAction extends BaseAction {
	private static Logger logger = Logger.getLogger(GroovyDispatchAction.class);

    /**
     * create a new URLPermission.
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     */
    public ActionForward executeShell(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    	 DynaActionForm dyna = (DynaActionForm)form;
         String scriptText = (String)dyna.get("scriptText");
         GroovyShell gs = new GroovyShell();
         try {
			Object result = gs.evaluate(scriptText);
			dyna.set("scriptResult",result);
		 } catch (CompilationFailedException e) {
            logger.error("groovy Error=",e);
		 }

		 return mapping.findForward("executeShell");
    }
    /**
     * create a new URLPermission.
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     */
    public ActionForward executeSafeShell(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    	 DynaActionForm dyna = (DynaActionForm)form;
         final String scriptText = (String)dyna.get("scriptText");
         final GroovyShell gs = new GroovyShell();
         final Object result;
         AuthorizationManager am = (AuthorizationManager) request.getSession().getServletContext().getAttribute(SecurityConstants.AUTHORIZATION_MANAGER);
         AccessControlContext acc = null;
		try {
			acc = AccessControlContextUtils.getRestrictedAccessControlContext((RolePrincipal) am.readPrincipal("guest"));
		} catch (AuthorizationException e1) {
			e1.printStackTrace();
		}
		System.setSecurityManager(new SecurityManager());
		try{
         result = AccessController.doPrivileged(
	         new PrivilegedAction() {
			        	 public Object run() {
			        		 Object scriptResult = null;
			        		 try {
			        			 //System.setSecurityManager(new SecurityManager());
			        			 scriptResult = gs.evaluate(scriptText);
							} catch (CompilationFailedException e) {
								logger.error(e.getMessage());
							}
			        	 return scriptResult;
			             }
			 },acc);
         dyna.set("scriptResult",result);
		}catch(SecurityException sex){
			dyna.set("scriptResult",sex.getMessage());
		}

		 return mapping.findForward("executeShellOK");
    }
}
